local Enum = require("common.Enum")

local P = {}

P.PAY_ITEM_ID = {
    IAP_ITEM_ID1 = 36,
    IAP_ITEM_ID2 = 37,
    IAP_ITEM_ID3 = 38,
    IAP_ITEM_ID4 = 39,
    IAP_ITEM_ID5 = 35,
    IAP_ITEM_ID6 = 40,
    IAP_ITEM_ID7 = 41,
    IAP_ITEM_ID8 = 42,
}

--[[IOS product id]]
P.PRODUCT_ID = {
    IAP1 = "com.gameislive.shanhai.15stone",
    IAP2 = "com.gameislive.shanhai.50stone",
    IAP3 = "com.gameislive.shanhai.180stone",--原来为32000
    IAP4 = "com.gameislive.shanhai.400stone",
    IAP5 = "com.gameislive.shanhai.welcome",
    IAP6 = "com.gameislive.shanhai.bigpackage",
    IAP7 = "com.gameislive.shanhai.1000stone",
    IAP8 = "com.gameislive.shanhai.reward",
}

--[[Android Google Play product id]]
P.ANDROID_PRODUCT_ID = {
    IAP1 = "demonsouls_gempack_1",
    IAP2 = "demonsouls_gempack_2",
    IAP3 = "demonsouls_gempack_3",
    IAP4 = "demonsouls_gempack_4",
    IAP5 = "demonsouls_welcome_bundle",
    IAP6 = "demonsouls_fortune_bundle",
    IAP7 = "demonsouls_gempack_5",
    IAP8 = "demonsouls_reward_2",
}

function P.getProductIdList()
    local productTable = P.PRODUCT_ID
    
    local osType = lk.LakooManager:getInstance():getOSType()
    if osType == Enum.OS_TYPE.ANDROID then
        productTable = P.ANDROID_PRODUCT_ID
    end

    local productIdList = ""
    for key, var in pairs(productTable) do
        productIdList = productIdList..var..","
    end
    return productIdList
end

function P.getProductIdByItemId(itemId)
    local productTable = P.PRODUCT_ID

    local osType = lk.LakooManager:getInstance():getOSType()
    if osType == Enum.OS_TYPE.ANDROID then
        productTable = P.ANDROID_PRODUCT_ID
    end

    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID1 then
        return productTable.IAP1
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID2 then
        return productTable.IAP2
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID3 then
        return productTable.IAP3
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID4 then
        return productTable.IAP4
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID5 then
        return productTable.IAP5
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID6 then
        return productTable.IAP6
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID7 then
        return productTable.IAP7
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID8 then
        return productTable.IAP8
    end

    return nil
end

function P.getCurrencyByItemId(itemId)
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID1 then
        return 0.99
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID2 then
        return 2.99
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID3 then
        return 9.99
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID4 then
        return 19.99
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID5 then
        return 0.99
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID6 then
        return 19.99
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID7 then
        return 49.99
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID8 then
        return 1.99
    end
end

function P.getVirtualCurrencyByItemId(itemId)
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID1 then
        return 15
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID2 then
        return 50
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID3 then
        return 180
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID4 then
        return 400
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID5 then
        return 15
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID6 then
        return 400
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID7 then
        return 1000
    end
    if itemId == P.PAY_ITEM_ID.IAP_ITEM_ID8 then
        return 0
    end
end

function P.getPayType(channel)
   local payType = nil
   if channel == Enum.CHANNEL.IOS_APPSTORE then
        payType = Enum.PAY_TYPE.APPLE_STORE
   end 
   
   if channel == Enum.CHANNEL.ANDROID_PHONE_GOOGLE then
        payType = Enum.PAY_TYPE.GOOGLE_PLAY
   end
   
   --TODO:WP and Android TV
   
   return payType
end

return P