local Enum = require("common.Enum")
local IDX = require("conf.TextIndex")
local GamePool = require("model.GamePool")

local cc = cc
local math = math

P = {}

function P.get(textIndex)
    local TextPack = nil
    
    local localLang = GamePool.getLocalLang()
    cclog("localLang:%d",localLang)
    if localLang == Enum.LANG.NONE then
        local currentLanguageType = cc.Application:getInstance():getCurrentLanguage()
        --cclog("lang type==%d",currentLanguageType)

        if currentLanguageType == cc.LANGUAGE_CHINESE then
            TextPack = require('conf.ZH_CN')
        elseif currentLanguageType == cc.LANGUAGE_ENGLISH then
            TextPack = require('conf.EN')
        elseif currentLanguageType == cc.LANGUAGE_ZH_HK then
            TextPack = require('conf.ZH_HK')
        elseif currentLanguageType == cc.LANGUAGE_JAPANESE then
            TextPack = require('conf.JP')
        else
            TextPack = require('conf.EN')
        end
    else
        if localLang == Enum.LANG.ZH_CN then
            TextPack = require('conf.ZH_CN')
        elseif localLang == Enum.LANG.EN then
            TextPack = require('conf.EN')
        elseif localLang == Enum.LANG.ZH_HK then
            TextPack = require('conf.ZH_HK')
        elseif localLang == Enum.LANG.JP then
            TextPack = require('conf.JP')
        else
            TextPack = require('conf.EN')
        end
    end

    
    return TextPack.texts[textIndex]
end

function P.getCurrentLang()
    local localLang = GamePool.getLocalLang()
    if localLang ~= Enum.LANG.NONE then
        return localLang
    end
    local text = P.get(IDX.PNG_TYPE)
    if text == "pngJP" then
    	return Enum.LANG.JP
    end
    if text == "pngEN" then
    	return Enum.LANG.EN
    end
    if text == "png" then
    	return Enum.LANG.ZH_CN
    end
    if text == "pngHK" then
    	return Enum.LANG.ZH_HK
    end
    
    return Enum.LANG.EN
end

return P