require "cocos.init"
local UILib = require("common.UILib")
local Enum = require("common.Enum")

local cc = cc
local class = class

local AbsLayer = class("AbsLayer",
    function()
        return cc.Layer:create()
    end
)

AbsLayer.__index = AbsLayer

function AbsLayer:create()


    local absLayer = AbsLayer.new()
    absLayer:init()
    
    return absLayer
end

function AbsLayer:init()
    -- handling touch events
    local function onTouchBegan(touch, event)
        BeginPos = touch:getLocation()
        -- CCTOUCHBEGAN event must return true
        return true
    end
    
    local listener = cc.EventListenerTouchOneByOne:create()
    listener:setSwallowTouches(true)--如果不加入此句消息依旧会向下传递
    listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self)
end

function AbsLayer:addNormalBackground()
    local bgSprite = cc.Sprite:create("testRes/t_bg.png")
    self:setContentSize(bgSprite:getContentSize());
    bgSprite:setPosition(UILib.UI_ANCHOR_POINT.ZERO.x, UILib.UI_ANCHOR_POINT.ZERO.y)
    self:addChild(bgSprite);
    
    return bgSprite
end

---在Layer左上角添加关闭按钮
--@return #MenuImage 返回实现button
function AbsLayer:addBackBtn()
    local backMenu = cc.Menu:create();
    backMenu:setLocalZOrder(100);
    backMenu:ignoreAnchorPointForPosition(false);
    backMenu:setPosition(UILib.UI_ANCHOR_POINT.ZERO.x, UILib.UI_ANCHOR_POINT.ZERO.y);
    backMenu:setContentSize(self:getContentSize());
    self:addChild(backMenu);
    
    local backBtn = cc.MenuItemImage:create("testRes/t_close_1.png", "testRes/t_close_2.png", "testRes/t_close_2.png");
    backMenu:addChild(backBtn, 1);
    local btnSize = backBtn:getContentSize();
    local p = UILib.offsetWithSuperSize(0,0,btnSize.width,btnSize.height,backMenu:getContentSize().width,backMenu:getContentSize().height,UILib.UI_ANCHOR.TOP_RIGHT)
    backBtn:setPosition(p);
    
    return backBtn;
end

---获取UI动画起始或结束点
function AbsLayer:getTargetPosition(type)
    local width = self:getContentSize().width
    local height = self:getContentSize().height
    local p= UILib.offset(0,0,width,height,UILib.UI_ANCHOR.CENTER)
    return p;
end


return AbsLayer