require "cocos.init"
local UILib = require("common.UILib")
local Enum = require("common.Enum")
local GamePool = require("model.GamePool")
local Text = require("conf.Text")
local TextIndex = require("conf.TextIndex")
local cc = cc
local class = class

local TAG = {
}

local googleConnectLayer = nil

local GoogleConnectLayer = class("GoogleConnectLayer",
    function()
        return cc.Node:create()
    end
)

GoogleConnectLayer.__index = GoogleConnectLayer

GoogleConnectLayer.callBackDelegate = nil

function GoogleConnectLayer:create()
    googleConnectLayer = GoogleConnectLayer.new() 
    googleConnectLayer:init()  
    return googleConnectLayer
end

function GoogleConnectLayer:init()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    self:setContentSize(visibleSize)
    self:setAnchorPoint(UILib.UI_ANCHOR_POINT.CENTER)
    local pos = UILib.offset(0,0,self:getContentSize().width,self:getContentSize().height,UILib.UI_ANCHOR.CENTER)
    self:setPosition(pos)

    local bgLayer = cc.LayerColor:create(UILib.UI_COLOR4B.GRAY)
    bgLayer:setContentSize(visibleSize)
    self:addChild(bgLayer)
    
    ---#####禁止穿透
    local eventListener = cc.EventListenerTouchOneByOne:create()
    local function onTouchBegan(touch, event)  
        self.callBackDelegate:onConnectNotice() 
        return true
    end
    local function onTouchEnded(touch, event)
    end

    eventListener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
    eventListener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED)
    eventListener:setSwallowTouches(true)
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(eventListener, self)
    ---#####
    
    local bgImg = ccui.ImageView:create(Enum.IMG_NAME_PNGHK.WARN_BG)
    pos = UILib.offsetWithSuperSize(0,0,bgImg:getContentSize().width,bgImg:getContentSize().height,self:getContentSize().width,self:getContentSize().height,UILib.UI_ANCHOR.CENTER)
    bgImg:setPosition(pos)
    self:addChild(bgImg)
    bgImg:setScaleX(1.5)
    
    local msg = Text.get(TextIndex.GOOGLE_CONNECT_TIPS)
    --cc.size(XXX, 0):自动调整高度
    local msgLabel = CCLabelTTF:create(msg, UILib.FONT_NAME_NORMAL, UILib.FONT.SMALL, cc.size(bgImg:getContentSize().width*1.5-20, 0), kCCVerticalTextAlignmentCenter, kCCTextAlignmentCenter)
    if msgLabel ~= nil then
        msgLabel:setColor(UILib.UI_COLOR3B.BLACK)
        pos = UILib.offsetWithSuperSize(0,0,msgLabel:getContentSize().width,msgLabel:getContentSize().height,self:getContentSize().width,self:getContentSize().height,UILib.UI_ANCHOR.CENTER)
        msgLabel:setPosition(pos)
        self:addChild(msgLabel)

        local rate = (msgLabel:getContentSize().height+20)/bgImg:getContentSize().height
        bgImg:setScaleY(rate)
    end
end

function GoogleConnectLayer:setDelegate(delegate)
    self.callBackDelegate = delegate
end

return GoogleConnectLayer