require "cocos.init"
local UILib = require("common.UILib")
local Enum = require("common.Enum")
local AbsLayer = require("gameUI.layer.AbsLayer")

local cc = cc
local class = class

local TAG = {
}

local LoadingLayer = class("LoadingLayer",
    function()
        return AbsLayer:create()
    end
)

LoadingLayer.__index = LoadingLayer

LoadingLayer.bgLayer = nil

function LoadingLayer:create()
    local loadingLayer = LoadingLayer.new() 
    loadingLayer:init()  
    return loadingLayer
end

function LoadingLayer:init()

    local visibleSize = cc.Director:getInstance():getVisibleSize()
    self:setContentSize(visibleSize)
    self:setAnchorPoint(UILib.UI_ANCHOR_POINT.CENTER)
    local pos = UILib.offset(0,0,self:getContentSize().width,self:getContentSize().height,UILib.UI_ANCHOR.CENTER)
    self:setPosition(pos)

    self.bgLayer = cc.LayerColor:create(UILib.UI_COLOR4B.GRAY)
    self.bgLayer:setContentSize(visibleSize)
    self:addChild(self.bgLayer)
    
    ---#####禁止穿透
    local eventListener = cc.EventListenerTouchOneByOne:create()
    local function onTouchBegan(touch, event)         
        return true
    end
    local function onTouchEnded(touch, event)
    end

    eventListener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
    eventListener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED)
    eventListener:setSwallowTouches(true)
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(eventListener, self)
    ---#####
    
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("LoadingAnim.csb")
    local loadingAnim = ccs.Armature:create("LoadingAnim")
    self:addChild(loadingAnim)
    loadingAnim:getAnimation():playWithIndex(0)
    local pos = cc.p(visibleSize.width/2,visibleSize.height/2)
    loadingAnim:setPosition(pos)
end

function LoadingLayer:removeBgLayer()
    if self.bgLayer == nil then
    	return
    end
    self.bgLayer:removeFromParent(true)
end

return LoadingLayer