require "cocos.init"
local UILib = require("common.UILib")
local Enum = require("common.Enum")

local Text = require("conf.Text")
local IDX = require("conf.TextIndex")

local GamePool = require("model.GamePool")

local cc = cc
local class = class

local TAG = {
}

local MessageLayer = class("MessageLayer",
    function()
        return cc.Node:create()
    end
)

-- joe
local ControllerHolder = class("ControllerHolder")
function ControllerHolder:ctor()
    self.controller  = nil
    self._holderNode = nil

    self._leftJoystick = nil
    self._rightJoystick = nil

    self._dpadLeft = nil
    self._dpadRight = nil
    self._dpadUp = nil
    self._dpadDown = nil

    self._buttonX = nil
    self._buttonY = nil
    self._buttonA = nil
    self._buttonB = nil

    self._buttonL1 = nil
    self._buttonR1 = nil
    self._buttonL2 = nil
    self._buttonR2 = nil

    self.deviceLabel = nil
    self.externalKeyLabel = nil
end
--

MessageLayer.__index = MessageLayer
MessageLayer.isfinishTap = true
MessageLayer.tapTimes = 0

function MessageLayer:create(msg)
    local messageLayer = MessageLayer.new() 
    messageLayer:init(msg)  
    return messageLayer
end

function MessageLayer:init(msg)
    self:setName("MessageLayer")
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    self:setContentSize(visibleSize)
    self:setAnchorPoint(UILib.UI_ANCHOR_POINT.CENTER)
    local pos = UILib.offset(0,0,self:getContentSize().width,self:getContentSize().height,UILib.UI_ANCHOR.CENTER)
    self:setPosition(pos)

    local bgLayer = cc.LayerColor:create(UILib.UI_COLOR4B.GRAY)
    bgLayer:setContentSize(visibleSize)
    self:addChild(bgLayer)
    
    ---#####禁止穿透
    local eventListener = cc.EventListenerTouchOneByOne:create()
    local function onTouchBegan(touch, event)         
        return true
    end
    lk.LakooManager:getInstance():setIsHasPopTip(true)
    --cclog("Message setIsHasPopTip")
    local function onTouchEnded(touch, event)
        lk.LakooManager:getInstance():setIsHasPopTip(false)
        self:removeFromParent(true)
    end

    eventListener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
    eventListener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED)
    eventListener:setSwallowTouches(true)
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(eventListener, self)
    
    local osType = Enum.OS_TYPE.IOS
    osType = lk.LakooManager:getInstance():getOSType()
    if osType == Enum.OS_TYPE.ANDROID then
    --joe
        self._firstHolder   = ControllerHolder.new()
        self._firstHolder.controller = nil
        self:registerControllerListener()
    --
    end
    ---#####
    
    local extMsg = nil
    local m, n = string.find(msg, "@")--[[每日奖励信息分割--]]
    if m ~= nil and n ~= nil then
        local subString = string.sub(msg,1,m-1)
        local subString2 = string.sub(msg,n+1,string.len(msg))
        msg = subString
        extMsg = subString2
    end
    
    local bgImg = ccui.ImageView:create(Enum.IMG_NAME_PNGHK.WARN_BG)
    pos = UILib.offsetWithSuperSize(0,0,bgImg:getContentSize().width,bgImg:getContentSize().height,self:getContentSize().width,self:getContentSize().height,UILib.UI_ANCHOR.CENTER)
    bgImg:setPosition(pos)
    self:addChild(bgImg)
  
    --cc.size(XXX, 0):自动调整高度
    local msgLabel = CCLabelTTF:create(msg, UILib.FONT_NAME_NORMAL, UILib.FONT.SMALL, cc.size(bgImg:getContentSize().width-10, 0), kCCVerticalTextAlignmentCenter, kCCTextAlignmentCenter)
    if msgLabel ~= nil then
        msgLabel:setColor(UILib.UI_COLOR3B.BLACK)
        pos = UILib.offsetWithSuperSize(0,0,msgLabel:getContentSize().width,msgLabel:getContentSize().height,self:getContentSize().width,self:getContentSize().height,UILib.UI_ANCHOR.CENTER)
        msgLabel:setPosition(pos)
        self:addChild(msgLabel)
        
        local rate = (msgLabel:getContentSize().height+20)/bgImg:getContentSize().height
        bgImg:setScaleY(rate)
    end
    
    --[[每日奖励充值后的额外奖励信息--]]
    if extMsg ~= nil and extMsg ~= "" then
    	extMsg = Text.get(IDX.ADDITIONAL)..extMsg
    	
        local extBgImg = ccui.ImageView:create(Enum.IMG_NAME_PNGHK.WARN_BG)
        self:addChild(extBgImg)
        
        local extMsgLabel = CCLabelTTF:create(extMsg, UILib.FONT_NAME_NORMAL, UILib.FONT.SMALL, cc.size(extBgImg:getContentSize().width-10, 0), kCCVerticalTextAlignmentCenter, kCCTextAlignmentCenter)
        if extMsgLabel ~= nil then
            extMsgLabel:setColor(UILib.UI_COLOR3B.BLACK)
            pos = cc.p(bgImg:getPositionX(),bgImg:getPositionY()-bgImg:getContentSize().height/2*bgImg:getScaleY()-20)
            extMsgLabel:setPosition(pos)
            self:addChild(extMsgLabel)

            local rateY = (extMsgLabel:getContentSize().height+20)/extBgImg:getContentSize().height
            extBgImg:setScaleY(rateY)
        end
        
        extBgImg:setPosition(pos)
        
        local dailyRewardIcon = UILib.createClipSprite(UILib.IMG_IDX.IMG91,94)
        if dailyRewardIcon ~= nil then
            local rateX = (extBgImg:getContentSize().width+dailyRewardIcon:getContentSize().width*2)/extBgImg:getContentSize().width
            extBgImg:setScaleX(rateX)
            
            pos = cc.p(extBgImg:getPositionX()-extBgImg:getContentSize().width/2*rateX+dailyRewardIcon:getContentSize().width,extBgImg:getPositionY())
            dailyRewardIcon:setPosition(pos)
            self:addChild(dailyRewardIcon)
        end    
    end
    
    local i, j = string.find(msg, "#")
    if i ~= nil and j ~= nil then
        local k, f = string.find(msg, "#",i+1)
        --cclog("i:%d,k:%d",i,k)
        if k ~= nil and f ~= nil then      
            local subString = string.sub(msg,i+1,k-1)
            --cclog("subString:%s",subString)
            local si, sj = string.find(subString,",")
            local iconImgIdx = string.sub(subString,1,si-1)
            local iconIdx = string.sub(subString,sj+1,string.len(subString))
            cclog("icomImg:%s,iconIdx:%s",iconImgIdx,iconIdx) 
            
            --msg = string.gsub(msg,string.sub(msg,i,k), "")
            --msgLabel:setString(msg)
            msgLabel:removeFromParent(true)
            msgLabel = nil
            
            local msg1 = string.sub(msg,1,i-1)--"获得"
            local msg2 = string.sub(msg, k+1, string.len(msg))--"itemName X 数量"
            --cclog("msg1:%s,msg2:%s",msg1,msg2)
            
            local icon = UILib.createClipSprite(tonumber(iconImgIdx),tonumber(iconIdx))            
            self:addChild(icon)
            
            local msg1Label = cc.Label:create()
            msg1Label:setString(msg1)
            msg1Label:setSystemFontSize(UILib.FONT.SMALL)
            msg1Label:setColor(UILib.UI_COLOR3B.BLACK)
            self:addChild(msg1Label)
            
            local msg2Label = cc.Label:create()
            msg2Label:setString(msg2)
            msg2Label:setSystemFontSize(UILib.FONT.SMALL)
            msg2Label:setColor(UILib.UI_COLOR3B.BLACK)
            self:addChild(msg2Label)
            
            local totalWidth = msg1Label:getContentSize().width + icon:getContentSize().width + msg2Label:getContentSize().width
            local dx = (self:getContentSize().width - totalWidth)/2 + msg1Label:getContentSize().width/2
            local dy = self:getContentSize().height/2
            msg1Label:setPosition(cc.p(dx, dy))
            
            dx = dx + msg1Label:getContentSize().width/2 + icon:getContentSize().width/2
            icon:setPosition(cc.p(dx, dy))
            
            dx = dx + icon:getContentSize().width/2 + msg2Label:getContentSize().width/2
            msg2Label:setPosition(cc.p(dx, dy))
            
            local rate = (totalWidth+20)/bgImg:getContentSize().width
            bgImg:setScaleX(rate)
        end
    end
end

--joe
function MessageLayer:registerControllerListener()
    local function onConnectController(controller, event)
        if controller == nil or controller == self._firstHolder.controller then
            return
        end

        local deviceInfo = string.format("%s id:%d", controller:getDeviceName(), controller:getDeviceId())
        cclog("MessageLayer deviceInfo ="..deviceInfo)

        if self._firstHolder.controller == nil then
            self._firstHolder.controller = controller
        end
    end

    local function onDisconnectedController(controller, event)
        if self._firstHolder.controller == controller then
            self._firstHolder.controller = nil
        end
    end

    local function showButtonState(controller, keyCode, isPressed)
        onConnectController(controller, nil)
        local holder = nil

        if controller == self._firstHolder.controller then
            holder = self._firstHolder
        else    
            return
        end
        
        if lk.LakooManager:getInstance():getIsHasPopView() == true then
            return
        end
        
        local scene = cc.Director:getInstance():getRunningScene()
        local child = scene:getChildren()

        for var = 1,#child do
            local sc = child[var]
            if var == #child then
                if sc:getName() ~= self:getName() then
                    cclog("MessageLayer no top")
                    return
                end
            end
        end

        if isPressed then
            cclog("MessageLayer key down")
            if keyCode == cc.ControllerKey.BUTTON_A then
                if self.isfinishTap == true then
                    self.isfinishTap = false
                end
--                if self.tapTimes == 0 then
--                    self.tapTimes = 1
--                    return
--                end
            elseif keyCode == cc.ControllerKey.BUTTON_B then
            elseif keyCode == cc.ControllerKey.BUTTON_X then
            elseif keyCode == cc.ControllerKey.BUTTON_Y then
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_UP then
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_DOWN then
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_LEFT then
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_RIGHT then
            elseif keyCode == cc.ControllerKey.BUTTON_LEFT_SHOULDER then
            elseif keyCode == cc.ControllerKey.BUTTON_RIGHT_SHOULDER then
            elseif keyCode == cc.ControllerKey.BUTTON_LEFT_THUMBSTICK then
            elseif keyCode == cc.ControllerKey.BUTTON_RIGHT_THUMBSTICK then
            else
                local ketStatus = string.format("Key Down:%d",keyCode)
            end
        else
            cclog("MessageLayer key up")
            if keyCode == cc.ControllerKey.BUTTON_A then
                if self.isfinishTap == false then
                    self.isfinishTap = true 
                    lk.LakooManager:getInstance():setIsHasPopTip(false)
                    self:removeFromParent(true)
                    cclog("MessageLayer removeFromParent")
                end
            elseif keyCode == cc.ControllerKey.BUTTON_B then
                
            elseif keyCode == cc.ControllerKey.BUTTON_X then
            elseif keyCode == cc.ControllerKey.BUTTON_Y then
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_UP then
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_DOWN then
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_LEFT then

            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_RIGHT then

            elseif keyCode == cc.ControllerKey.BUTTON_LEFT_SHOULDER then
            elseif keyCode == cc.ControllerKey.BUTTON_RIGHT_SHOULDER then
            elseif keyCode == cc.ControllerKey.BUTTON_LEFT_THUMBSTICK then
            elseif keyCode == cc.ControllerKey.BUTTON_RIGHT_THUMBSTICK then
            else
                local ketStatus = string.format("Key up:%d",keyCode)
            end
        end
    end 

    local function onKeyDown(controller, keyCode, event)
        showButtonState(controller, keyCode, true)
    end

    local function onKeyUp(controller, keyCode, event)
        showButtonState(controller, keyCode, false)
    end

    local function onAxisEvent(controller, keyCode, event)
        local holder = nil

        if controller == self._firstHolder.controller then
            holder = self._firstHolder
        else
            return
        end

        local ketStatus = controller:getKeyStatus(keyCode)
        if keyCode == cc.ControllerKey.JOYSTICK_LEFT_X then
            if(ketStatus.value == -1) then
            elseif(ketStatus.value == 1) then

            end
        elseif keyCode == cc.ControllerKey.JOYSTICK_LEFT_Y then
        elseif keyCode == cc.ControllerKey.JOYSTICK_RIGHT_X then
        elseif keyCode == cc.ControllerKey.JOYSTICK_RIGHT_Y then
        elseif keyCode == cc.ControllerKey.AXIS_LEFT_TRIGGER then
        elseif keyCode == cc.ControllerKey.AXIS_RIGHT_TRIGGER then
        else
        --do nothing
        end
    end

    local controllerListener = cc.EventListenerController:create()
    controllerListener:registerScriptHandler(onConnectController, cc.Handler.EVENT_CONTROLLER_CONNECTED)
    controllerListener:registerScriptHandler(onDisconnectedController, cc.Handler.EVENT_CONTROLLER_DISCONNECTED)

    controllerListener:registerScriptHandler(onKeyDown, cc.Handler.EVENT_CONTROLLER_KEYDOWN)
    controllerListener:registerScriptHandler(onKeyUp, cc.Handler.EVENT_CONTROLLER_KEYUP)
    controllerListener:registerScriptHandler(onAxisEvent, cc.Handler.EVENT_CONTROLLER_AXIS)

    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(controllerListener, self)

    cc.Controller:startDiscoveryController()
end
--

return MessageLayer
