---暂时只用于角色死亡后弹出的选项使用12/01/2014
require "cocos.init"
local UILib = require("common.UILib")
local Enum = require("common.Enum")
local Util = require("common.Util")
local AbsLayer = require("gameUI.layer.AbsLayer")

local WarningLayer = require("gameUI.layer.WarningLayer")
local GamePool = require("model.GamePool")

local LayerStage = require("manager.LayerStage")
local SceneStage = require("manager.SceneStage")

local cc = cc
local class = class

local TAG = {
    BUT_REBORN = 1,
    BUT_SHOP = 2,
    BUT_BACK_TITLE = 3,
    BUT_ADS_REBORN = 4,
}

-- joe
local preTab = 1
local btnIdxMax = 1
local Anim = {}
local btnTag = {}
local ControllerHolder = class("ControllerHolder")
function ControllerHolder:ctor()
    self.controller  = nil
    self._holderNode = nil

    self._leftJoystick = nil
    self._rightJoystick = nil

    self._dpadLeft = nil
    self._dpadRight = nil
    self._dpadUp = nil
    self._dpadDown = nil

    self._buttonX = nil
    self._buttonY = nil
    self._buttonA = nil
    self._buttonB = nil

    self._buttonL1 = nil
    self._buttonR1 = nil
    self._buttonL2 = nil
    self._buttonR2 = nil

    self.deviceLabel = nil
    self.externalKeyLabel = nil
end
--

local MultipChoiceLayer = class("MultipChoiceLayer",
    function()
        return AbsLayer:create()
    end
)

MultipChoiceLayer.__index = MultipChoiceLayer

function MultipChoiceLayer:create()
    local multipChoiceLayer = MultipChoiceLayer.new() 
    multipChoiceLayer:init()  
    return multipChoiceLayer
end

function MultipChoiceLayer:init()
    self:setName("MultipChoiceLayer")

    self.adsReviveTimes = lk.LakooManager:getInstance():getReviveTimes()
    self.adsReviveCD = lk.LakooManager:getInstance():getReviveCD()*60

    self.adsTimes = lk.LakooManager:getInstance():getAdsTimes("2")
    if self.adsTimes == nil then
        self.adsTimes = 0
    end
    self.adsNextTime = lk.LakooManager:getInstance():getAdsNextTime("2")
    if self.adsNextTime > self.adsReviveCD then
        lk.LakooManager:getInstance():resetAds("2")
    end

    lk.LakooManager:getInstance():initGADInterstitial()

    local visibleSize = cc.Director:getInstance():getVisibleSize()
    self:setContentSize(visibleSize)
    self:setAnchorPoint(UILib.UI_ANCHOR_POINT.CENTER)
    local pos = UILib.offset(0,0,self:getContentSize().width,self:getContentSize().height,UILib.UI_ANCHOR.CENTER)
    self:setPosition(pos)

    --lk.LakooManager:getInstance():initRewardVideo(Enum.ADMOB_REWARD_VIDEO_LIST.REWARD_REBORN)

    local bgLayer = cc.LayerColor:create(UILib.UI_COLOR4B.GRAY)
    bgLayer:setContentSize(visibleSize)
    self:addChild(bgLayer)
    
    ---#####禁止穿透
    local eventListener = cc.EventListenerTouchOneByOne:create()
    local function onTouchBegan(touch, event)         
        return true
    end
    local function onTouchEnded(touch, event)
    end

    eventListener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
    eventListener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED)
    eventListener:setSwallowTouches(true)
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(eventListener, self)
    ---#####

    local function update(delta)
        local ads_state = lk.LakooManager:getInstance():getVideoAdsStateInfo()
        if ads_state == 1 then
            self:doReborn(true)
            lk.LakooManager:getInstance():setVideoAdsStateInfo(0)
        end
    end

    self.nextTimeLabel = cc.Label:create()
    self.nextTimeLabel:setString(lk.LakooManager:getInstance():getString(Enum.TEXT.T_WATCH_ADS))
    local function updateNextTime(delta)
        if self.adsNextTime <= self.adsReviveCD and self.adsReviveTimes ~= 0 and self.adsNextTime > 0 and self.adsTimes >= self.adsReviveTimes then
            local nextTime = self.adsReviveCD - self.adsNextTime
            local minute = math.floor(nextTime/60)
            local second = nextTime - minute*60
            local time = minute..":"
            if second < 10 then
                time = time.."0"..second
            else
                time = time..second
            end
            self.adsNextTime = self.adsNextTime + 1
            if nextTime == 0 then
                time = ""
                lk.LakooManager:getInstance():resetAds("2")
            end
            local str = lk.LakooManager:getInstance():getString(Enum.TEXT.T_WATCH_ADS)
            local timeStr = str.."  "..time
            self.nextTimeLabel:setString(timeStr)
        end
    end
    local function onNodeEvent(event)
        if "enterTransitionFinish" == event then
            self.scheduleID = cc.Director:getInstance():getScheduler():scheduleScriptFunc(update, 0.1, false)
            self.scheduleTime = cc.Director:getInstance():getScheduler():scheduleScriptFunc(updateNextTime, 1, false)
        end
        if "exit" == event then
            if self.scheduleID ~= nil then
                cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.scheduleID)
            end
            if self.scheduleTime ~= nil then
                cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.scheduleTime)
            end
        end
    end
    self:registerScriptHandler(onNodeEvent)

    local osType = Enum.OS_TYPE.IOS
    osType = lk.LakooManager:getInstance():getOSType()
    if osType == Enum.OS_TYPE.ANDROID then
        --joe
        self._firstHolder   = ControllerHolder.new()
        self._firstHolder.controller = nil
        self:registerControllerListener()
        --
    end
    
    local titleTable = {}
    
    local tIdx = 1
    local rebornTitle = ""
    local rebornItemJson =  lk.LakooManager:getInstance():getItemInfoJsonFromBagById(Enum.ITEM_ID.REBORN_ITEM_ID)
    if rebornItemJson ~= "" then
        local item = Util.json2Table(rebornItemJson)
        local itemId = item[Enum.ITEM_KEY.ID]
        if itemId > 0 then
        	local itemName = item[Enum.ITEM_KEY.NAME]
            local quantity = item[Enum.ITEM_KEY.QUANTITY]
            rebornTitle = string.format("%s X %d",itemName, quantity)
            table.insert(titleTable,tIdx,rebornTitle)
            tIdx = tIdx + 1
        end
    end
    
    -- local shopTitle = lk.LakooManager:getInstance():getString(Enum.TEXT.T_SHOP)
    -- table.insert(titleTable,tIdx,shopTitle)
    -- tIdx = tIdx + 1
    local backTitle = lk.LakooManager:getInstance():getString(Enum.TEXT.T_BACK_TO_TITLE)
    table.insert(titleTable,tIdx,backTitle)
    tIdx = tIdx + 1
    if lk.LakooManager:getInstance():getAdsIsReady() == true then
        local adsRebornTitle = lk.LakooManager:getInstance():getString(Enum.TEXT.T_WATCH_ADS)
        table.insert(titleTable, tIdx, adsRebornTitle)
        tIdx = tIdx + 1
    end

    local function touchButton(sender, eventType) 
        if eventType == ccui.TouchEventType.began then
        end
        if eventType == ccui.TouchEventType.moved then
        --cclog("moved---")
        end
        if eventType == ccui.TouchEventType.ended then
            local tag = sender:getTag()
            if tag == TAG.BUT_REBORN then
                self:doReborn(false)
            elseif tag == TAG.BUT_SHOP then
                self:doShop()
            elseif tag == TAG.BUT_BACK_TITLE then
                self:doPopBackMainMenu()
            elseif tag == TAG.BUT_ADS_REBORN then
                if self.adsNextTime <= self.adsReviveCD and self.adsReviveTimes ~= 0 and self.adsNextTime > 0 and self.adsTimes >= self.adsReviveTimes then
                    local language = lk.LakooManager:getInstance():getCurrentLang()
                    local msg = ""
                    if language == 2 then
                        msg = "The video isn't ready yet!"
                    elseif language == 3 then
                        msg = "视频还没准备好哦！"
                    elseif language == 4 then
                        msg = "視頻還沒準備好哦！"
                    elseif language == 5 then
                        msg = "ビデオはまだ準備していない！"
                    end
                    lk.LakooManager:getInstance():addPopTip(msg)
                else
                    lk.LakooManager:getInstance():showVideoAdsView(Enum.ADMOB_REWARD_VIDEO_LIST.REWARD_REBORN)
                end
            end
        end
    end
    
    local function onKeyReleaseed(code,event)
        if code == 6 then
            
        end
    end

    local key_listener = cc.EventListenerKeyboard:create()
    key_listener:registerScriptHandler(onKeyReleaseed,cc.Handler.EVENT_KEYBOARD_RELEASED)
    if eventDispatcher ~= nil then
        eventDispatcher:addEventListenerWithSceneGraphPriority(key_listener, self)
    end
    
    local drawX = 0
    local drawY = 0
    local intervalY = 6
    
    preTab = 1
    btnIdxMax = 1
    Anim = {}
    btnTag = {}
--    local chooiceBtn = nil
    for var=1, #titleTable do
        local button = ccui.Button:create(Enum.IMG_NAME_PNGHK.WARN_BG,Enum.IMG_NAME_PNGHK.WARN_BG,Enum.IMG_NAME_PNGHK.WARN_BG)
        
        local bgPanel = cc.Node:create()
        bgPanel:setContentSize(cc.size(button:getContentSize().width,button:getContentSize().height*0.3))
        
        if var == 1 then
        	drawX = self:getContentSize().width/2 - bgPanel:getContentSize().width/2
        	local mod = math.fmod(#titleTable,2)
        	local size = 0
        	local offsetY = 0
        	if mod == 1 then
        		size = (#titleTable)/2
        	else
        	    size  = (#titleTable-1)/2
        	    offsetY = intervalY/2
        	end
        	drawY = self:getContentSize().height/2+bgPanel:getContentSize().height*size + offsetY
        else
            drawY = drawY - bgPanel:getContentSize().height - intervalY
        end
        pos = cc.p(drawX, drawY)
        bgPanel:setPosition(pos)
        self:addChild(bgPanel)
        
        
        local subPos = cc.p(bgPanel:getContentSize().width/2,bgPanel:getContentSize().height/2)
        button:setPosition(subPos)
        button:setScale(1, 0.3)
        button:setTag(self:getTagByTitle(titleTable[var]))
        button:addTouchEventListener(touchButton)
        bgPanel:addChild(button)
        
        if GamePool.isAndroidTV() then
            btnIdxMax = var
            ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("FocusAni2.csb")
            local anim =ccs.Armature:create("FocusAni2") 
            anim:setLocalZOrder(99)
            anim:setPosition(subPos)
            anim:getAnimation():playWithIndex(0)
            if var == 1 then
                anim:setVisible(true)
            else
                anim:setVisible(false)
            end
            bgPanel:addChild(anim)
            table.insert(btnTag,var,self:getTagByTitle(titleTable[var]))
            table.insert(Anim,var,anim)
        end
        -- self.nextTime
        if titleTable[var] == lk.LakooManager:getInstance():getString(Enum.TEXT.T_WATCH_ADS) then
            self.nextTimeLabel:setSystemFontSize(UILib.FONT.SMALL_PLUS)
            self.nextTimeLabel:setColor(UILib.UI_COLOR3B.BLACK)
            self.nextTimeLabel:setPosition(subPos)
            bgPanel:addChild(self.nextTimeLabel)
        else
            local label = cc.Label:create()
            label:setString(titleTable[var])
            label:setSystemFontSize(UILib.FONT.SMALL_PLUS)
            label:setColor(UILib.UI_COLOR3B.BLACK)--[[不能用setTextColor,否则无法显示--]]
            label:setPosition(subPos)
            bgPanel:addChild(label)
        end
    end
end

function MultipChoiceLayer:getTagByTitle(_title)
    if _title == lk.LakooManager:getInstance():getString(Enum.TEXT.T_SHOP) then
    	return TAG.BUT_SHOP
    end
    if _title == lk.LakooManager:getInstance():getString(Enum.TEXT.T_BACK_TO_TITLE) then
    	return TAG.BUT_BACK_TITLE
    end
    if _title == lk.LakooManager:getInstance():getString(Enum.TEXT.T_WATCH_ADS) then
        return TAG.BUT_ADS_REBORN
    end
    return TAG.BUT_REBORN
end

function MultipChoiceLayer:doShop()
    local scene = cc.Director:getInstance():getRunningScene()
    local layer = scene:getChildByTag(Enum.LAYER_TYPE.SINGLE_POP_MAIN_SHOP)
    if layer ~= nil then
        layer:setLocalZOrder(99)--[[调整到最上层--]]
    else
        LayerStage.setShowLayerType(Enum.LAYER_TYPE.SINGLE_POP_MAIN_SHOP)
    end
end

function MultipChoiceLayer:doPopBackMainMenu() 
    local layer = WarningLayer:create()
    GamePool.getCurrentScene():addChild(layer)
    layer:setDelegate(self)
    local msg = lk.LakooManager:getInstance():getString(Enum.TEXT.T_WHETHER_RETURN_TITLE)
    local okText = lk.LakooManager:getInstance():getString(Enum.TEXT.T_YES)
    local cancelText = lk.LakooManager:getInstance():getString(Enum.TEXT.T_NO)
    layer:setString(msg, okText, cancelText)
end

function MultipChoiceLayer:onActionFunc()
    self:removeFromParent(true)
    SceneStage.setNextType(Enum.SCENE_TYPE.TITLE,UILib.TRANSITION_TYPE.FADE)
end

function MultipChoiceLayer:doReborn(isAds)
    local flag = lk.LakooManager:getInstance():reborn(isAds)
    if flag then
        self:removeFromParent(true)
    end
end

--joe
function MultipChoiceLayer:registerControllerListener()
    local function onConnectController(controller, event)
        if controller == nil or controller == self._firstHolder.controller then
            return
        end

        local deviceInfo = string.format("%s id:%d", controller:getDeviceName(), controller:getDeviceId())
        cclog("MultipChoiceLayer deviceInfo ="..deviceInfo)

        if self._firstHolder.controller == nil then
            self._firstHolder.controller = controller
        end
    end

    local function onDisconnectedController(controller, event)
        if self._firstHolder.controller == controller then
            self._firstHolder.controller = nil
        end
    end
    
    local function showButtonState(controller, keyCode, isPressed)
        onConnectController(controller, nil)
        local holder = nil

        if controller == self._firstHolder.controller then
            holder = self._firstHolder
        else    
            return
        end
        
        local scene = cc.Director:getInstance():getRunningScene()
        local child = scene:getChildren()
        
        local topSence = child[#child]
        if topSence:getName() ~= self:getName() then 
            cclog("MultipChoiceLayer no top")
            return
        end

        if lk.LakooManager:getInstance():getIsHasPopView() == true then
            return
        end
        
        if isPressed then
            if keyCode == cc.ControllerKey.BUTTON_A then
                local tag = btnTag[preTab]
                if tag == TAG.BUT_REBORN then
                    self:doReborn(false)
                elseif tag == TAG.BUT_SHOP then
                    self:doShop()
                elseif tag == TAG.BUT_BACK_TITLE then
                    self:doPopBackMainMenu()
                end
            elseif keyCode == cc.ControllerKey.BUTTON_B then
            elseif keyCode == cc.ControllerKey.BUTTON_X then
            elseif keyCode == cc.ControllerKey.BUTTON_Y then
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_UP then
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_DOWN then
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_LEFT then
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_RIGHT then
            elseif keyCode == cc.ControllerKey.BUTTON_LEFT_SHOULDER then
            elseif keyCode == cc.ControllerKey.BUTTON_RIGHT_SHOULDER then
            elseif keyCode == cc.ControllerKey.BUTTON_LEFT_THUMBSTICK then
            elseif keyCode == cc.ControllerKey.BUTTON_RIGHT_THUMBSTICK then
            else
                local ketStatus = string.format("Key Down:%d",keyCode)
            end
        else
            cclog("MultipChoiceLayer keyup ="..keyCode)
            if keyCode == cc.ControllerKey.BUTTON_A then
            elseif keyCode == cc.ControllerKey.BUTTON_B then
            elseif keyCode == cc.ControllerKey.BUTTON_X then
            elseif keyCode == cc.ControllerKey.BUTTON_Y then
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_UP then
                if preTab == 1 then
                    return
                end
                local nextTab = preTab - 1
                if nextTab > btnIdxMax then
                    return
                end
                preTab = nextTab
                for var=1, #Anim do
                    local anim = Anim[var]
                    if var == preTab then 
                        anim:setVisible(true)
                    else
                        anim:setVisible(false)
                    end
                end
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_DOWN then
                if preTab == btnIdxMax then
                    return
                end
                local nextTab = preTab + 1
                if nextTab < 1 then
                    return
                end
                preTab = nextTab
                for var=1, #Anim do
                    local anim = Anim[var]
                    if var == preTab then 
                        anim:setVisible(true)
                    else
                        anim:setVisible(false)
                    end
                end 
            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_LEFT then

            elseif keyCode == cc.ControllerKey.BUTTON_DPAD_RIGHT then

            elseif keyCode == cc.ControllerKey.BUTTON_LEFT_SHOULDER then
            elseif keyCode == cc.ControllerKey.BUTTON_RIGHT_SHOULDER then
            elseif keyCode == cc.ControllerKey.BUTTON_LEFT_THUMBSTICK then
            elseif keyCode == cc.ControllerKey.BUTTON_RIGHT_THUMBSTICK then
            else
                local ketStatus = string.format("Key up:%d",keyCode)
            end
        end
    end 

    local function onKeyDown(controller, keyCode, event)
        showButtonState(controller, keyCode, true)
    end

    local function onKeyUp(controller, keyCode, event)
        showButtonState(controller, keyCode, false)
    end

    local function onAxisEvent(controller, keyCode, event)
        local holder = nil

        if controller == self._firstHolder.controller then
            holder = self._firstHolder
        else
            return
        end

        if lk.LakooManager:getInstance():getIsHasPopView() == true then
            return
        end
        
        local ketStatus = controller:getKeyStatus(keyCode)
        if keyCode == cc.ControllerKey.JOYSTICK_LEFT_X then
            if(ketStatus.value == -1) then
            elseif(ketStatus.value == 1) then

            end
        elseif keyCode == cc.ControllerKey.JOYSTICK_LEFT_Y then
           
        elseif keyCode == cc.ControllerKey.JOYSTICK_RIGHT_X then
        elseif keyCode == cc.ControllerKey.JOYSTICK_RIGHT_Y then
        elseif keyCode == cc.ControllerKey.AXIS_LEFT_TRIGGER then
        elseif keyCode == cc.ControllerKey.AXIS_RIGHT_TRIGGER then
        else
        --do nothing
        end
    end

    local controllerListener = cc.EventListenerController:create()
    controllerListener:registerScriptHandler(onConnectController, cc.Handler.EVENT_CONTROLLER_CONNECTED)
    controllerListener:registerScriptHandler(onDisconnectedController, cc.Handler.EVENT_CONTROLLER_DISCONNECTED)

    controllerListener:registerScriptHandler(onKeyDown, cc.Handler.EVENT_CONTROLLER_KEYDOWN)
    controllerListener:registerScriptHandler(onKeyUp, cc.Handler.EVENT_CONTROLLER_KEYUP)
    controllerListener:registerScriptHandler(onAxisEvent, cc.Handler.EVENT_CONTROLLER_AXIS)

    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(controllerListener, self)

    cc.Controller:startDiscoveryController()
end
--

return MultipChoiceLayer
