require "cocos.init"
require "cocos.extension.ExtensionConstants"
local UILib = require("common.UILib")
local Enum = require("common.Enum")

local cc = cc
local class = class

local RedeemCodeLayer = class("RedeemCodeLayer",
    function()
        return cc.Node:create()
    end
)

RedeemCodeLayer.__index = RedeemCodeLayer

RedeemCodeLayer.editBox = nil

function RedeemCodeLayer:create(callBack)
    local redeemCodeLayer = RedeemCodeLayer.new()
    redeemCodeLayer:init(callBack)
    return redeemCodeLayer
end

function RedeemCodeLayer:init(callBack)
    print("兑换码init.......")

    local visibleSize = cc.Director:getInstance():getVisibleSize()
    self:setContentSize(visibleSize)
    self:setAnchorPoint(UILib.UI_ANCHOR_POINT.CENTER)
    local pos = UILib.offset(0,0,self:getContentSize().width,self:getContentSize().height,UILib.UI_ANCHOR.CENTER)
    self:setPosition(pos)

    local bgLayer = cc.LayerColor:create(UILib.UI_COLOR4B.GRAY)
    bgLayer:setContentSize(visibleSize)
    self:addChild(bgLayer)

    ---#####禁止穿透
    local eventListener = cc.EventListenerTouchOneByOne:create()
    local function onTouchBegan(touch, event)
        return true
    end
    local function onTouchEnded(touch, event)
    end

    eventListener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
    eventListener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED)
    eventListener:setSwallowTouches(true)
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(eventListener, self)
    ---#####

    --back button
    local function doBackAction(sender, eventType)
        if eventType == ccui.TouchEventType.began then
        end
        if eventType == ccui.TouchEventType.moved then
        end
        if eventType == ccui.TouchEventType.ended then
            self:removeFromParent(true)
        end
    end
    local backButton = ccui.Button:create(Enum.IMG_NAME_PNGHK.BACK,Enum.IMG_NAME_PNGHK.BACK,Enum.IMG_NAME_PNGHK.BACK)
    local pos = UILib.offset(0,0,backButton:getContentSize().width,backButton:getContentSize().height,UILib.UI_ANCHOR.TOP_RIGHT)
    backButton:setPosition(pos)
    self:addChild(backButton)
    backButton:addTouchEventListener(doBackAction)

    local function editBoxTextEventHandle()
        -- if event == "return" then--other:began,ended,changed
            callBack(self.editBox:getText())
        -- end

    end

    local editBoxSize = cc.size(300,50)
	-- cc.EditBox & cc.Scale9Sprite was deprecated
    self.editBox = ccui.EditBox:create(editBoxSize, ccui.Scale9Sprite:create("editBox_bg.png"))
    local pos = UILib.offset(0,-50,self.editBox:getContentSize().width,self.editBox:getContentSize().height,UILib.UI_ANCHOR.CENTER_TOP)
    self.editBox:setPosition(pos)
    self.editBox:setFontSize(25)
    self.editBox:setFontColor(UILib.UI_COLOR3B.WHITE)
    local redeeCodeStr = lk.LakooManager:getInstance():getString(Enum.TEXT.T_BONUS)
    self.editBox:setPlaceHolder(redeeCodeStr)
    self.editBox:setPlaceholderFontColor(UILib.UI_COLOR3B.WHITE)
    self.editBox:setMaxLength(100)
    self.editBox:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE)
    --Handler
    -- self.editBox:registerScriptEditBoxHandler(editBoxTextEventHandle)
    self:addChild(self.editBox)

    self.sendBtn = ccui.Button:create(Enum.IMG_NAME_PNGHK.BUTTON_BG,Enum.IMG_NAME_PNGHK.BUTTON_BG,Enum.IMG_NAME_PNGHK.BUTTON_BG)
    self.sendBtn:setTag(100)
    local x=pos.x 
    local y=pos.y - 50

    self.sendBtn:setPosition(cc.p(x,y))
    self:addChild(self.sendBtn)
    self.sendBtn:addTouchEventListener(editBoxTextEventHandle)

    local textLabel = UILib.textAddStroke("OK",UILib.FONT_NAME_NORMAL,UILib.FONT.SMALL,UILib.UI_COLOR3B.WHITE,UILib.UI_COLOR3B.BLACK,1)
    textLabel:setTag(101)
    pos = UILib.offsetWithSuperSize(0,0,textLabel:getContentSize().width,textLabel:getContentSize().height,self.sendBtn:getContentSize().width,self.sendBtn:getContentSize().height,UILib.UI_ANCHOR.CENTER)
    textLabel:setPosition(pos)
    self.sendBtn:addChild(textLabel)


end

return RedeemCodeLayer
