require "cocos.init"
local SceneStage = require("manager.SceneStage")
local UILib = require("common.UILib")
local Enum = require("common.Enum")
local Util = require("common.Util")

local Text = require("conf.Text")
local IDX = require("conf.TextIndex")
local Config = require("conf.LKConfig")

local cc = cc
local class = class
local lk = lk

local TAG = {
}

local LogoScene = class("LogoScene",
    function()
        return cc.Layer:create()
    end
)

LogoScene.__index = LogoScene

function LogoScene:create()
    local logoScene = LogoScene.new()
    logoScene:init()

    local scene = cc.Scene:create()--创建场景
    scene:addChild(logoScene)
    return scene
end

function LogoScene:init()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    self:setContentSize(visibleSize)
    local pos = cc.p(0,0)
    self:setPosition(pos)
    
    local bgLayer = cc.LayerColor:create(UILib.UI_COLOR4B.WHITE)
    bgLayer:setContentSize(visibleSize)
    self:addChild(bgLayer)
    
    --Util.playMusic("8.mp3",false)
    lk.LakooManager:getInstance():playMusic(8,false)
    
    ---#####禁止穿透
    local eventListener = cc.EventListenerTouchOneByOne:create()
    local function onTouchBegan(touch, event)        
        return true
    end
    local function onTouchEnded(touch, event) 
    end

    eventListener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
    eventListener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED)
    eventListener:setSwallowTouches(true)
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(eventListener, self)
    ---#####
    
    local aniName = Text.get(IDX.LOGO_ANI_NAME)
    local sX = 0.5--visibleSize.width/Config.STANDARD_WIDTH
    local sY = 0.5--visibleSize.height/Config.STANDARD_HEIGHT
    lk.LakooManager:getInstance():addLKAnimationNode(self, aniName, -1, -1, -1, -1, visibleSize.width/2, visibleSize.height/2, sX, sY)

    local function update()
        if lk.LakooManager:getInstance():getIsLogoAniFinish() then            
            SceneStage.setNextType(Enum.SCENE_TYPE.TITLE,UILib.TRANSITION_TYPE.FADE)
        end
    end
    

    local function onNodeEvent(event)
        if "enterTransitionFinish" == event then
            self.scheduleID = cc.Director:getInstance():getScheduler():scheduleScriptFunc(update, 0, false)
        end
        if "exit" == event then
            if self.scheduleID ~= nil then
                cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.scheduleID)
            end
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

return LogoScene
