cc.FileUtils:getInstance():setPopupNotify(false)
cc.FileUtils:getInstance():addSearchPath("src/")--[[必需放require "cocos.init"前头，否则release模式进入游戏时会黑屏--]]
cc.FileUtils:getInstance():addSearchPath("res/")

require "cocos.init"

-- cclog
cclog = function(...)
    print(string.format(...))
end

-- for CCLuaEngine traceback
function __G__TRACKBACK__(msg)
    cclog("----------------------------------------")
    cclog("LUA ERROR: " .. tostring(msg) .. "\n")
    cclog(debug.traceback())
    --call c++ function
    --onLuaException(tostring(msg), debug.traceback())
    cclog("----------------------------------------")
    return msg
end

local function main()
    collectgarbage("collect")
    -- avoid memory leak
    collectgarbage("setpause", 100)
    collectgarbage("setstepmul", 5000)
    
    cc.FileUtils:getInstance():addSearchPath("res/CocosAni/")
    
    cc.FileUtils:getInstance():addSearchPath("res/HK_RES/HK_dat/")
    cc.FileUtils:getInstance():addSearchPath("res/HK_RES/HK_image/")
    cc.FileUtils:getInstance():addSearchPath("res/HK_RES/HK_map/")
    cc.FileUtils:getInstance():addSearchPath("res/HK_RES/HK_text/")
    cc.FileUtils:getInstance():addSearchPath("res/HK_RES/HK_title/")
    cc.FileUtils:getInstance():addSearchPath("res/HK_RES/HK_ui/")
    
    cc.FileUtils:getInstance():addSearchPath("res/ZH_RES/ZH_dat/")
    cc.FileUtils:getInstance():addSearchPath("res/ZH_RES/ZH_image/")
    cc.FileUtils:getInstance():addSearchPath("res/ZH_RES/ZH_map/")
    cc.FileUtils:getInstance():addSearchPath("res/ZH_RES/ZH_text/")
    cc.FileUtils:getInstance():addSearchPath("res/ZH_RES/ZH_title/")
    cc.FileUtils:getInstance():addSearchPath("res/ZH_RES/ZH_ui/")
    
    cc.FileUtils:getInstance():addSearchPath("res/EN_RES/EN_dat/")
    cc.FileUtils:getInstance():addSearchPath("res/EN_RES/EN_image/")
    cc.FileUtils:getInstance():addSearchPath("res/EN_RES/EN_map/")
    cc.FileUtils:getInstance():addSearchPath("res/EN_RES/EN_text/")
    cc.FileUtils:getInstance():addSearchPath("res/EN_RES/EN_title/")
    cc.FileUtils:getInstance():addSearchPath("res/EN_RES/EN_ui/")
    
    cc.FileUtils:getInstance():addSearchPath("res/JP_RES/JP_dat/")
    cc.FileUtils:getInstance():addSearchPath("res/JP_RES/JP_image/")
    cc.FileUtils:getInstance():addSearchPath("res/JP_RES/JP_map/")
    cc.FileUtils:getInstance():addSearchPath("res/JP_RES/JP_text/")
    cc.FileUtils:getInstance():addSearchPath("res/JP_RES/JP_title/")
    cc.FileUtils:getInstance():addSearchPath("res/JP_RES/JP_ui/")
    
    cc.FileUtils:getInstance():addSearchPath("res/RES_map_image/")
    
    cc.FileUtils:getInstance():addSearchPath("res/magicSprite/")
    cc.FileUtils:getInstance():addSearchPath("res/specialFraData/")
    cc.FileUtils:getInstance():addSearchPath("res/spriteData/")
    
    cc.FileUtils:getInstance():addSearchPath("res/RES_controller/")
    cc.FileUtils:getInstance():addSearchPath("res/res_head/head_ani/sprite/")
    
    cc.FileUtils:getInstance():addSearchPath("res/res_music/")
    cc.FileUtils:getInstance():addSearchPath("res/res_sound/")
    
    cc.FileUtils:getInstance():addSearchPath("res/res_other")
    cc.FileUtils:getInstance():addSearchPath("res/res_other/fragment/")
    
    local LKConfig = require("conf.LKConfig")
    local frameSize = cc.Director:getInstance():getOpenGLView():getFrameSize()
    local ratio = (frameSize.width * LKConfig.STANDARD_HEIGHT) / (frameSize.height * LKConfig.STANDARD_WIDTH)
    local sWidth = LKConfig.STANDARD_WIDTH
    local sHeight = LKConfig.STANDARD_HEIGHT
    if ratio >= 1 then
        --屏的宽高比大于或等于480:320，以高为320做基准
        --(Fit size to iPhone3/3G/4/5/5S)
        sWidth = LKConfig.STANDARD_WIDTH * ratio
    else
        --屏的宽高比小于480:320，以宽为480做基准
        --(Fit size to iPad/NewPad)
        sHeight = LKConfig.STANDARD_HEIGHT / ratio
    end
    
    cc.Director:getInstance():getOpenGLView():setDesignResolutionSize(sWidth, sHeight, 1)
    lk.LakooManager:getInstance():setScreenSize(sWidth, sHeight)
    
    --此处设置只对IOS生效，Android需要修改Cocos2dxRenderer.java
    --http://discuss.cocos2d-x.org/t/setanimationinterval-does-nothing-on-android/6419中的neo_kim回复
    --2014-08-21 已update了cocos2d-x官方修改版：
    --https://github.com/cocos2d/cocos2d-x/blob/1643c29a000d2e6720a2eb36e118ed7461487473/cocos/platform/android/java/src/org/cocos2dx/lib/Cocos2dxRenderer.java
    --如需修改Android的话，需要将＋private static long sAnimationInterval = ...;中的60改为30
    cc.Director:getInstance():setAnimationInterval(1.0 / 60)
    cc.Director:getInstance():setDisplayStats(false)

    --Tapjoy init
    local Enum = require("common.Enum")
    local osType = Enum.OS_TYPE.IOS
    local tapjoyId = LKConfig.TAPJOY_ID_IOS
    local secretKey = LKConfig.TAPJOY_KEY_IOS
    osType = lk.LakooManager:getInstance():getOSType()
    if osType == Enum.OS_TYPE.ANDROID then
        tapjoyId = LKConfig.TAPJOY_ID_ANDROID
        secretKey = LKConfig.TAPJOY_KEY_ANDROID
    end
    lk.LakooManager:getInstance():initTapjoy(tapjoyId,secretKey)

    --android Google Play Service
    lk.LakooManager:getInstance():googleApiClientInit()
 
    local payUtil = require("common.PayUtil")
    lk.LakooManager:getInstance():initPayList(payUtil.getProductIdList())
    --处理IOS充值异常
    lk.LakooManager:getInstance():checkUndonePurchase()
    
    lk.LakooManager:getInstance():initZendesk()
    
    local gamePool = require("model.GamePool")
    gamePool.init()
    
    --[[一定要在gamePool.init之后，否则channel错误--]]
    local channel = lk.LakooManager:getInstance():getChannel()
    lk.LakooManager:getInstance():initTalkingData(LKConfig.TALKING_DATA_APP_ID, channel)
    
    local networkManager = require("manager.NetworkManager")
    networkManager.init()
    
    local sceneManager = require("manager.SceneManager")
    sceneManager.init()
    local layerManager = require("manager.LayerManager")
    layerManager.init()

    lk.LakooManager:getInstance():initRemoteConfig()
    lk.LakooManager:getInstance():initGADInterstitial()
    lk.LakooManager:getInstance():initRewardVideo(Enum.ADMOB_REWARD_VIDEO_LIST.REWARD_STONE)
end


local status, msg = xpcall(main, __G__TRACKBACK__)
if not status then
    error(msg)
end
