require "cocos.init"

local cc = cc
local class = class

local NetWork = class("NetWork",
    function()
        return cc.Node:create()
    end
)

NetWork.__index = NetWork

function NetWork:create()
    local netWork = NetWork.new() 
    netWork:init()  
    return netWork
end

function NetWork:init()
    local function update()
    end

    local function onNodeEvent(event)
        if "enterTransitionFinish" == event then
            self.scheduleID = cc.Director:getInstance():getScheduler():scheduleScriptFunc(update, 0, false)
        end
        if "exit" == event then
            if self.scheduleID ~= nil then
                cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.scheduleID)
            end
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

function NetWork:request(_protocol,_parmJson,callback)
    cclog("protocol:%s\n parmJson:%s",_protocol,_parmJson)
    
    local xhr = cc.XMLHttpRequest:new() -- 新建一个XMLHttpRequest对象
    if xhr == nil then
    	return
    end
    
    xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_JSON
    
    xhr:open("POST", _protocol)-- POST方式
    
--    xhr:setRequestHeader("param", "665286295133")    -- 提交的参数  
--    xhr:setRequestHeader("productId", "com.gameislive.shanhai.15stone")
    
    local function onReadyStateChange()
        -- 显示状态码,成功显示200
        if xhr == nil then
        	cclog("self.xhr==nil")
        	return
        end
        if xhr.status ~= 200 then
            cclog("请求出错(Code:%d)",xhr.status)
            --callback({msg = "Network error.Code:"..xhr.status})
            return
        end
        cclog("Http Status Code:"..xhr.statusText)
        local response = xhr.response -- 获得响应数据
        local output = json.decode(response,1) -- 解析json数据
        table.foreach(output,function(i, v) print (i..":", v) end)
        
        callback(output)
    end
    -- 注册脚本方法回调
    xhr:registerScriptHandler(onReadyStateChange)
    local param = nil
    if _parmJson ~= nil then
        param = "param=".._parmJson
    end
    if param == nil then
        xhr:send()-- 发送请求
    else
        xhr:send(param)-- 发送请求
    end
    
end

function NetWork:putMessageToMailChimp(_email, _parmJson)
    if _email == nil or _email == "" then
        cclog("putMessageToMailChimp _email is nil!")
    	return
    end
    cclog("putMessageToMailChimp parmJson:%s",_parmJson)
    
    local xhr = cc.XMLHttpRequest:new() -- 新建一个XMLHttpRequest对象
    if xhr == nil then
        return
    end

    xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_JSON
    
    local md5Email = lk.LakooManager:getInstance():getMD5String(_email)
    local protocol = "https://us2.api.mailchimp.com/3.0/lists/0967b544e0/members/"..md5Email.."/"

    xhr:open("PUT", protocol)-- PUT方式

    local authValue = "Basic dXNlcm5hbWU6N2U3OTliY2Y1NDM3MmZhZGQ1Y2E4MzRlMWU3Y2IxYTMtdXMy"
    xhr:setRequestHeader("Authorization", authValue)    -- 提交的验证参数  

    local function onReadyStateChange()
        -- 显示状态码,成功显示200
        if xhr == nil then
            cclog("self.xhr==nil")
            return
        end
        if xhr.status ~= 200 then
            cclog("请求出错(Code:%d)",xhr.status)
            return
        end
        cclog("Http Status Code:"..xhr.statusText)
        local response = xhr.response -- 获得响应数据
        local output = json.decode(response,1) -- 解析json数据
        table.foreach(output,function(i, v) print (i..":", v) end)
    end
    -- 注册脚本方法回调
    xhr:registerScriptHandler(onReadyStateChange)
    if _parmJson == nil then
        xhr:send()-- 发送请求
    else
        xhr:send(_parmJson)-- 发送请求
    end

end

return NetWork